import { snippetCompletion } from '@codemirror/autocomplete';
import { LRLanguage, StreamLanguage, indentNodeProp, delimitedIndent, foldNodeProp, foldInside, LanguageSupport, syntaxHighlighting } from '@codemirror/language';
import { jinja2 } from '@codemirror/legacy-modes/mode/jinja2';
import { parseMixed } from '@lezer/common';
import { styleTags, tags, classHighlighter } from '@lezer/highlight';
import { vscodeDarkInit } from '@uiw/codemirror-theme-vscode';
import { LRParser } from '@lezer/lr';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = LRParser.deserialize({
  version: 14,
  states: "1WQ]QPOOOqQQO'#CbOvQQO'#CwO{QQO'#CyO!QQQO'#DSO!VQQO'#DTO![QQO'#DUOOQO'#C`'#C`OOQO'#DV'#DVQ]QPOOO!aQPO,58|O!fQPO,59cO!kQPO,59eO!pQPO,59nO!uQPO,59oO!zQPO,59pOOQO-E7T-E7TO#PQQO1G.hO#[QQO1G.}O#gQQO1G/PO#oQQO1G/YO#gQQO1G/ZO#wQQO1G/[O$PQQO'#CeO$UQQO'#CmOOQO'#DW'#DWO$aQQO7+$SOOQO7+$S7+$SO$lQQO'#CxOOQO'#DZ'#DZO$zQQO7+$iOOQO7+$i7+$iO%VQPO'#C{O%[QPO'#CzO%dQQO'#CzO%lQPO7+$kO%qQSO'#C|OOQO'#D]'#D]O&SQQO7+$tOOQO7+$t7+$tO&[QPO7+$uO&aQQO7+$vOOQO7+$v7+$vO&iQPO,59PO&nQQO,59XO'PQQO'#CnO'hQPO'#CtOOQO'#Cq'#CqO$UQQO'#CoOOQO'#Co'#CoOOQO'#Cn'#CnOOQO-E7U-E7UOOQO<<Gn<<GnO'mQQO'#CvOOQO'#DY'#DYO'rQQO,59dOOQO-E7X-E7XOOQO<<HT<<HTO$UQQO,59gOOQO,59v,59vO(QQPO,59fOOQO-E7Y-E7YO(YQPO<<HVOOQO'#DO'#DOO(_OWO'#DROOQO'#C}'#C}O(gQQO'#C}OOQO,59h,59hOOQO-E7Z-E7ZOOQO<<H`<<H`O%}QPO<<HaOOQO<<Hb<<HbO(oO`O'#CfOOQO1G.k1G.kO$UQQO,59[O)TQQO1G.sOOQO,59^,59^OOQO,59_,59_O$UQQO,59`O)cQPO'#CpO)hQPO'#CnO)|QPO,59ZO&iQPO,59bOOQO-E7W-E7WO*UQPO1G/RP*aQPO'#D[O$UQQOAN=qOOOO'#DX'#DXO*fOWO'#CjO*nOPO,59mOOQO,59i,59iO*sQQO,59iOOQOAN={AN={O(_OWO'#CiO*{OWO'#CkOOQO,59Q,59QO+TOPO,59QO+YOPO,59WOOQO1G.v1G.vO+bQPO1G.zOOQO1G.u1G.uOOQO1G.|1G.|O+mQPOG23]OOOO-E7V-E7VOOQO1G/X1G/XOOQO1G/T1G/TO+uOPO,59TO+zOWO,59VOOOO,59V,59VOOQO1G.l1G.lOOQO1G.r1G.rO)OOQO1G.rO$UQQO7+$fO,SQQOLD(wOOOO1G.o1G.oOOOO1G.q1G.qO,[OPO7+$^O,aQPO<<HQO,lQQO!$'LcOOQO!$'Lc!$'LcOOQO<<Gx<<GxOOQOAN=lAN=lOOQO!)9A}!)9A}O$UQQO,59[",
  stateData: ",{~O!SOSPOSQOS~O!TPO!eQO!fRO!iSO!jTO!kUO~OVYO~OVZO~OV[O~OV]O~OV^O~OV_O~OWaO~OWbO~O!WcO~OWdO~O!WeO~OWfO~OTkOVhO!UgO~OToOVlO!UgO~OVpO!VnP~OTwOVtO~OTzOVtO~OV{O~OV!POi!OO!W!QO~OT!UOVhO!UgO~O!d!VOTlXVlX!UlX~OT!ZOVlO!UgO~O!g![O~O!^!]O!VnX~OVpO!VnX~O!V!`O~OW!dOZ!aOs!aOt!aO!Y!bO~OT!gOVtO~O!V!hO~OT!iOVtO~O!W!jO~O!_!lO!d!VOTaaVaa!Uaa~O!`!nO!a!oOTbXVbX!UbX!_bX!dbX~O!c!pO~OV!tO~O!d!VOTlaVla!Ula~O!^!]O!Vna~O!h!xO~O!Z!yO!X^P~OT!|OVtO~OV#TOZ#SO[#SO!V#RO!Y#PO!]#QO~O!d!VOTaiVai!Uai~O!_#oO~O!`!nO!a!oO!_bX!VbX!^bXWbX~O!V#WO!_bX~O!_#oO!Voi!^oi~O!^!]O~O!Z!yO!X^X~O!X#[O~OT#]OVtO~O!Z!yO![#`O~O!V#aO~O!V#bO!^#cO~O!^#dO!`!nO!a!oO~OW#eO!_#oO~O!X#fO~O!Z!yO![#gO~OT#kOVtO~O!V#lO~O!`!nO!a!oO!b#mO~OT#nOVtO~OsZiVt[~",
  goto: "&k!QPPPP!RP!VPP!Z!cPP!i!l!r!c!x!|#^#n#x$S$S$SP$^!V!_!V$d$j$q${%OPP%R!V!V!V%X%_%e%p%z&Q&XTWOXTVOXSiajTmbnQ!k{R#X!tR#S!jQ!{!bR#^#PQ#S!jR#h#cTiajQ|hQ!q!QQ!v![S#U!l#oR#Y!xS}h!lW!r!Q![!x#oQ#V!pR#i#dY!Sh![!l!x#oR!s!Qa!Rh!Q![!l!p!x#d#oa!Ph!Q![!l!p!x#d#oX!Wl|!X!mQscRxeSqceR!^raudfvy!d!}#e#jR!etR!ctQ!ctR#O!hQXOR`XQjaR!TjS!z!b#PS#Z!z#_R#_#QQ!XlQ!m|T!u!X!mQnbR!YnSrceR!_rQvdQyfW!fvy!}#jQ!}!dR#j#e",
  nodeNames: "⚠ MultilineComment TrailingComment Baml Decl } ClassDecl IdentifierDecl { BlockAttribute AttributeValue QuotedString UnquotedAttributeValue PromptExprNonJinja PromptExprContents JinjaExpr AttributeValue2 ClassField TypeExpr ComplexTypeExpr UnionTypeExpr SimpleTypeExpr ListTypeExpr OptionalTypeExpr MapTypeExpr MapIdentifier FieldAttribute EnumDecl EnumValueDecl FunctionDecl FunctionArgs FunctionArg TupleValue ValueExpr LiteralDecl NumericLiteral UnquotedString PromptExpr ClientDecl TemplateStringDecl TestDecl",
  maxTerm: 73,
  skippedNodes: [0,1,2],
  repeatNodeCount: 7,
  tokenData: "#MRoR!SOX$_XY(jYZ(jZ]$_]^(j^p$_pq(qqr$_rs*SstG`tw$_wxGmxyGryzGyz|$_|}HQ}!OHX!O!PKu!P!QNo!Q![! `![!]!&[!]!^$_!^!_!'o!_!`$_!`!a!'v!a!b!'}!b!c!)b!c!}!)q!}#O!+e#O#P$_#P#QGm#Q#R$_#R#S!)q#S#T$_#T#V!)q#V#W!+r#W#X!)q#X#Y!<s#Y#Z!DP#Z#a!)q#a#b#$k#b#h!)q#h#i#)|#i#o!)q#o#p#Hu#p#q#KX#q#r#Ll#r;'S$_;'S;=`#L{<%lO$_l$hb!ZWtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!P%p!Q!^%p!_!`%p!a!b%p!c!}%p#O#P%p#Q#o%p#p#q%p#r;'S%p;'S;=`(d<%lO%pd%wbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!P%p!Q!^%p!_!`%p!a!b%p!c!}%p#O#P%p#Q#o%p#p#q%p#r;'S%p;'S;=`(d<%lO%p`'Ub[`OX'PZ]'P^p'Ppq'Pqs'Ptw'Pz|'P}!P'P!Q!^'P!_!`'P!a!b'P!c!}'P#O#P'P#Q#o'P#p#q'P#r;'S'P;'S;=`(^<%lO'P`(aP;=`<%l'Pd(gP;=`<%l%p_(qO!ZW!SVo(zb!ZW!SV[`OX'PZ]'P^p'Ppq'Pqs'Ptw'Pz|'P}!P'P!Q!^'P!_!`'P!a!b'P!c!}'P#O#P'P#Q#o'P#p#q'P#r;'S'P;'S;=`(^<%lO'Pm*]n!ZWtS[`OX%pZ]%p^p%ppq,Zqr:krs<pstFqtw:kwz/mz|:k|}/m}!P:k!P!Q/m!Q!^:k!^!_/m!_!`:k!`!a/m!a!b:k!b!c/m!c!}:k!}#O/m#O#P>R#P#Q/m#Q#o:k#o#p/m#p#q:k#q#r/m#r;'S:k;'S;=`Fk<%lO:kd,`n[`OX'PZ]'P^p'Ppq,Zqr,Zrs.^st/mtw,Zwz/mz|,Z|}/m}!P,Z!P!Q/m!Q!^,Z!^!_/m!_!`,Z!`!a/m!a!b,Z!b!c/m!c!},Z!}#O/m#O#P2V#P#Q/m#Q#o,Z#o#p/m#p#q,Z#q#r/m#r;'S,Z;'S;=`:e<%lO,Zd.ebZd[`OX'PZ]'P^p'Ppq'Pqs'Ptw'Pz|'P}!P'P!Q!^'P!_!`'P!a!b'P!c!}'P#O#P'P#Q#o'P#p#q'P#r;'S'P;'S;=`(^<%lO'Pd/pWpq/mqr/mrs0Ys#O/m#O#P0_#P;'S/m;'S;=`2P<%lO/md0_OZdd0bXrs/m!P!Q/m#O#P/m#U#V/m#Y#Z/m#b#c/m#f#g/m#h#i/m#i#j0}d1QR!Q![1Z!c!i1Z#T#Z1Zd1^R!Q![1g!c!i1g#T#Z1gd1jR!Q![1s!c!i1s#T#Z1sd1vR!Q![/m!c!i/m#T#Z/md2SP;=`<%l/md2[o[`OX'PZ]'P^p'Ppq'Pqr'Prs,Ztw'Pz|'P}!P'P!P!Q/m!Q!^'P!_!`'P!a!b'P!c!}'P#O#P,Z#Q#U'P#U#V,Z#V#Y'P#Y#Z,Z#Z#b'P#b#c,Z#c#f'P#f#g,Z#g#h'P#h#i,Z#i#j4]#j#o'P#p#q'P#r;'S'P;'S;=`(^<%lO'Pd4bf[`OX'PZ]'P^p'Ppq'Pqs'Ptw'Pz|'P}!P'P!Q![5v![!^'P!_!`'P!a!b'P!c!i5v!i!}'P#O#P'P#Q#T'P#T#Z5v#Z#o'P#p#q'P#r;'S'P;'S;=`(^<%lO'Pd5{f[`OX'PZ]'P^p'Ppq'Pqs'Ptw'Pz|'P}!P'P!Q![7a![!^'P!_!`'P!a!b'P!c!i7a!i!}'P#O#P'P#Q#T'P#T#Z7a#Z#o'P#p#q'P#r;'S'P;'S;=`(^<%lO'Pd7ff[`OX'PZ]'P^p'Ppq'Pqs'Ptw'Pz|'P}!P'P!Q![8z![!^'P!_!`'P!a!b'P!c!i8z!i!}'P#O#P'P#Q#T'P#T#Z8z#Z#o'P#p#q'P#r;'S'P;'S;=`(^<%lO'Pd9Pf[`OX'PZ]'P^p'Ppq'Pqs'Ptw'Pz|'P}!P'P!Q![,Z![!^'P!_!`'P!a!b'P!c!i,Z!i!}'P#O#P'P#Q#T'P#T#Z,Z#Z#o'P#p#q'P#r;'S'P;'S;=`(^<%lO'Pd:hP;=`<%l,Zd:rntS[`OX%pZ]%p^p%ppq,Zqr:krs<pst/mtw:kwz/mz|:k|}/m}!P:k!P!Q/m!Q!^:k!^!_/m!_!`:k!`!a/m!a!b:k!b!c/m!c!}:k!}#O/m#O#P>R#P#Q/m#Q#o:k#o#p/m#p#q:k#q#r/m#r;'S:k;'S;=`Fk<%lO:kd<ybZdtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!P%p!Q!^%p!_!`%p!a!b%p!c!}%p#O#P%p#Q#o%p#p#q%p#r;'S%p;'S;=`(d<%lO%pd>YotS[`OX%pZ]%p^p%ppq'Pqr%prs:ktw%pz|%p}!P%p!P!Q/m!Q!^%p!_!`%p!a!b%p!c!}%p#O#P:k#Q#U%p#U#V:k#V#Y%p#Y#Z:k#Z#b%p#b#c:k#c#f%p#f#g:k#g#h%p#h#i:k#i#j@Z#j#o%p#p#q%p#r;'S%p;'S;=`(d<%lO%pd@bftS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!P%p!Q![Av![!^%p!_!`%p!a!b%p!c!iAv!i!}%p#O#P%p#Q#T%p#T#ZAv#Z#o%p#p#q%p#r;'S%p;'S;=`(d<%lO%pdA}ftS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!P%p!Q![Cc![!^%p!_!`%p!a!b%p!c!iCc!i!}%p#O#P%p#Q#T%p#T#ZCc#Z#o%p#p#q%p#r;'S%p;'S;=`(d<%lO%pdCjftS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!P%p!Q![EO![!^%p!_!`%p!a!b%p!c!iEO!i!}%p#O#P%p#Q#T%p#T#ZEO#Z#o%p#p#q%p#r;'S%p;'S;=`(d<%lO%pdEVftS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!P%p!Q![:k![!^%p!_!`%p!a!b%p!c!i:k!i!}%p#O#P%p#Q#T%p#T#Z:k#Z#o%p#p#q%p#r;'S%p;'S;=`(d<%lO%pdFnP;=`<%l:kmFvW!XXpq/mqr/mrs0Ys#O/m#O#P0_#P;'S/m;'S;=`2P<%lO/mmGeP!ZWrsGheGmO!YeWGrO!ZWZGyO!WR!ZWkHQO!Vc!ZWXHXO!^P!ZWoHdh!ZWVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!`!aKp!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pfJXgVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pPKuO!hPlLOc!ZWtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!P%p!Q![MZ![!^%p!_!`%p!a!b%p!c!}%p#O#P%p#Q#o%p#p#q%p#r;'S%p;'S;=`(d<%lO%pdMdcsStS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!P%p!Q![MZ![!^%p!_!`%p!a!b%p!c!}%p#O#P%p#Q#o%p#p#q%p#r;'S%p;'S;=`(d<%lO%p_NtP!ZW!P!QNwVN|SQVOYNwZ;'SNw;'S;=`! Y<%lONwV! ]P;=`<%lNwn! mg!ZWsSVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P!#U!Q![!$h![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pd!#]ctS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!P%p!Q![MZ![!^%p!_!`%p!a!b%p!c!}%p#O#P%p#Q#o%p#p#q%p#r;'S%p;'S;=`(d<%lO%pf!$sgsSVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P!#U!Q![!$h![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pm!&gb!gP!ZWtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!P%p!Q!^%p!_!`%p!a!b%p!c!}%p#O#P%p#Q#o%p#p#q%p#r;'S%p;'S;=`(d<%lO%pX!'vO!cP!ZWX!'}O!bP!ZWo!(Yb!aR!ZWtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!P%p!Q!^%p!_!`%p!a!b%p!c!}%p#O#P%p#Q#o%p#p#q%p#r;'S%p;'S;=`(d<%lO%pY!)iP!dQ!ZW!b!c!)lQ!)qO!UQn!)|g!ZWVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pZ!+jP!ZW#P#Q!+mR!+rO!`Ro!+}i!ZWVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#`JO#`#a!-l#a#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg!-ujVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#U!/g#U#]JO#]#^!4y#^#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg!/piVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#gJO#g#h!1_#h#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg!1hiVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#gJO#g#h!3V#h#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg!3bg!TPVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg!5SiVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#XJO#X#Y!6q#Y#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg!6ziVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#bJO#b#c!8i#c#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg!8riVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#hJO#h#i!:a#i#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg!:jhVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!^!_!<U!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pP!<XP#`#a!<[P!<_P#`#a!<bP!<eP#a#b!<hP!<kP!`!a!<nP!<sO!iPo!=Oi!ZWVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#bJO#b#c!>m#c#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg!>viVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#iJO#i#j!@e#j#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg!@niVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#aJO#a#b!B]#b#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg!Bhg!ePVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%po!D[i!ZWVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#iJO#i#j!Ey#j#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg!FSiVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#bJO#b#c!Gq#c#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg!GziVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#VJO#V#W!Ii#W#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg!IriVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#hJO#h#i!Ka#i#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg!KjiVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#]JO#]#^!MX#^#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg!MbiVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#cJO#c#d# P#d#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg# YiVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#bJO#b#c#!w#c#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg##Sg!fPVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pn#$vh!ZWVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#U#&b#U#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pf#&kiVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#dJO#d#e#(Y#e#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pf#(egiQVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%po#*Xi!ZWVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#XJO#X#Y#+v#Y#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg#,PkVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#aJO#a#b#-t#b#gJO#g#h#EZ#h#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg#-}iVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#dJO#d#e#/l#e#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg#/uiVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#`JO#`#a#1d#a#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg#1mhVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#U#3X#U#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg#3biVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#hJO#h#i#5P#i#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg#5YiVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#XJO#X#Y#6w#Y#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg#7QgVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#S#8i#S#T%p#T#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg#8riVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#gJO#g#h#:a#h#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg#:jiVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#hJO#h#i#<X#i#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg#<biVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#fJO#f#g#>P#g#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg#>YiVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#]JO#]#^#?w#^#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg#@QiVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#bJO#b#c#Ao#c#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg#AxiVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#ZJO#Z#[#Cg#[#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg#Crg!jPVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg#EdiVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#hJO#h#i#GR#i#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg#G^g!kPVbtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%po#H|QWT!ZW!P!Q#IS#o#p#KSV#IVP!P!Q#IYV#I]TO!P#IY!P!Q#Il!Q;'S#IY;'S;=`#J|<%lO#IYV#IoTO!P#IY!P!Q#JO!Q;'S#IY;'S;=`#J|<%lO#IYV#JRVO!P#IY!P!Q#JO!Q#q#IY#q#r#Jh#r;'S#IY;'S;=`#J|<%lO#IYV#JmTPVO!P#IY!P!Q#Il!Q;'S#IY;'S;=`#J|<%lO#IYV#KPP;=`<%l#IYb#KXO!]bo#Kdb!_R!ZWtS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!P%p!Q!^%p!_!`%p!a!b%p!c!}%p#O#P%p#Q#o%p#p#q%p#r;'S%p;'S;=`(d<%lO%pY#LsPTQ!ZW#q#r#LvW#L{O![Wl#MOP;=`<%l$_",
  tokenizers: [0, 1, 2, 3, 4],
  topRules: {"Baml":[0,3]},
  tokenPrec: 542
});

const BAMLLanguage = LRLanguage.define({
    parser: parser.configure({
        wrap: parseMixed((node) => {
            if (node.name !== 'PromptExprContents' && node.name !== 'JinjaExpr') {
                return null;
            }
            return {
                parser: StreamLanguage.define(jinja2).parser,
            };
        }),
        props: [
            indentNodeProp.add({
                Decl: delimitedIndent({ closing: '}', align: true }),
                // not sure the except is doing anything.
                PromptExpr: delimitedIndent({ closing: '#"', align: true }),
            }),
            foldNodeProp.add({
                ClassDecl: foldInside,
            }),
            styleTags({
                'Decl/*/"{" Decl/*/"}"': tags.brace,
                'ValueExpr/"{" ValueExpr/"}"': tags.brace,
                TestDecl: tags.keyword,
                'TestDecl/IdentifierDecl': tags.typeName,
                EnumDecl: tags.keyword,
                'EnumDecl/IdentifierDecl': tags.typeName,
                'EnumDecl/EnumValueDecl/IdentifierDecl': tags.propertyName,
                ClassDecl: tags.keyword,
                'ClassDecl/IdentifierDecl': tags.typeName,
                ClientDecl: tags.keyword,
                'ClientDecl/IdentifierDecl': tags.typeName,
                FunctionDecl: tags.keyword,
                'FunctionDecl/IdentifierDecl': tags.function(tags.variableName),
                'FunctionArg/IdentifierDecl': tags.variableName,
                'ClassField/IdentifierDecl': tags.propertyName,
                NumericLiteral: tags.number,
                QuotedString: tags.string,
                UnquotedString: tags.string,
                'AttributeValue/UnquotedAttributeValue': tags.string,
                FieldAttribute: tags.attributeName,
                'FieldAttribute/@': tags.attributeName,
                'FieldAttribute/IdentifierDecl': tags.attributeName,
                'BlockAttribute/@@': tags.attributeName,
                'BlockAttribute/IdentifierDecl': tags.attributeName,
                'SimpleTypeExpr/IdentifierDecl': tags.typeName,
                variable: tags.controlKeyword,
                PromptExpr: tags.string,
                'PromptExprNonJinja/...': tags.string,
                'PromptExprNonJinja/PromptExprContents/...': tags.operator,
                'TemplateStringDecl/IdentifierDecl': tags.attributeName,
                'TemplateStringDecl/PromptExpr': tags.string,
                'TupleValue/IdentifierDecl': tags.operator,
                TrailingComment: tags.comment,
                MultilineComment: tags.comment,
            }),
        ],
    }),
    languageData: {
        commentTokens: { line: '//' },
        closeBrackets: {
            brackets: ['(', '[', '"', '#"', '{'],
            stringPrefixes: ['#"'],
            wordChars: ['#', '"'],
        },
        snippetCompletion: true,
    },
});
const exampleCompletion = BAMLLanguage.data.of({
    autocomplete: [
        snippetCompletion('@alias(#"${one}"#)', { label: '@alias' }),
        snippetCompletion('@assert({{ this }})', { label: '@assert' }),
        snippetCompletion('@check(custom_check_name, {{ this }})', { label: '@check' }),
        snippetCompletion('@description(#"${}"#)', { label: '@description' }),
        snippetCompletion('class ${ClassName} {\n  ${property string}\n}', { label: 'class' }),
        snippetCompletion('enum ${EnumName} {\n  ${ONE}\n  ${TWO}\n}', { label: 'enum' }),
        snippetCompletion('function MyFunction(${arg: string}) -> ${YourOutputType} {\n  ${client YourClient}\n  prompt #"\n    ${add some instructions}\n  "#\n}', { label: 'function' }),
        snippetCompletion('prompt #"\n  {{ _.role("user") }}\n  INPUT:\n  ---\n  {{ your-variable }}\n  ---\n  Response:\n"#', { label: 'prompt #"' }),
        snippetCompletion('_.role("${role}")', { label: '_.role"' }),
        snippetCompletion('#"${mystring}"#', { label: '#"' }),
        snippetCompletion('client<llm> GPT4 {\n  provider baml-openai-chat\n  options {\n    model gpt4  \n}}', {
            label: 'client<llm> GPT4',
        }),
        snippetCompletion('template_string MyString(${arg1}: string) #"\n  A jinja string\n"#', {
            label: 'template_string',
        }),
    ],
});
const theme = vscodeDarkInit({
    styles: [
        {
            tag: [tags.variableName],
            color: '#dcdcaa',
        },
        {
            tag: [tags.brace],
            color: '#569cd6',
        },
        {
            tag: [tags.variableName, tags.propertyName],
            color: '#d4d4d4',
        },
        {
            tag: [tags.attributeName],
            color: '#c586c0',
        },
    ],
});
function BAML() {
    return new LanguageSupport(BAMLLanguage, [exampleCompletion, syntaxHighlighting(classHighlighter)]);
}

export { BAML, BAMLLanguage, theme };
